/*
*************************************************************
*												*
*			           QUESTRIP.C 					*
*												*
*************************************************************

questrip.c  --  A program to remove unnecessary empty lines from Wildcat 3.0
			 questionaire answer files.


*/

#include "stdio.h"
#include "graphics.h"
#include "cxlwin.h"
#include "cxlvid.h"
#include "conio.h"
#include "string.h"
#include "ctype.h"

#define	SIZE	4096

/* External variables and arrays */
char buffer[SIZE];
char whirl[6] = "*|/-\\";


main(argc, argv)

    int argc;
    char *argv[];

{

unsigned i;
extern char buffer[SIZE];   /* main read buffer */


int num, c, line;
char j, keychar, n, key, zaptemp;
FILE *infile;
FILE *outfile;

char *ptr;
char *miscptr;
char in_buffer[100];
char filename[80];
char filetemp[80];
char errormsg[80];

void error();
void command_hlp();


videoinit();       /* initialize the TCXL system. */
clrscrn();
zaptemp = 0;



prints(0,0,0x0F,"QUESTRIP Ver. 1.00  Copyright 1991 by C.E.Krehbiel");
prints(1,0,0x0F,"199 N. El Camino Real, Suite F175, Encinitas, CA 92024");
prints(2,0,0x0F,"ABC BBS  --  Educational Shareware  --  (619) 436-3525");
prints(4,0,0x0C,"QUESTRIP is released to the Wildcat Sysop community.  No payment");
prints(5,0,0x0C,"is required to use this program.  All rights are reserved.");
gotoxy(1,7);
puts("\nThis program removes empty lines generated by Wildcat 3.0 questionnaires.");
puts("Only blank lines will be removed.  The user(s) of this program is(are) solely ");
puts("responsible for its operation.  Use this program at your own risk.");
puts("Type QUESTRIP /? for more information.");

/* First to get the name of the file to process. */


if(argc > 1)
	{
	for(n=2; n <= argc; ++n)
		{
		strcpy(in_buffer, argv[n-1]);	/* Use in-buffer for temp storage */
          	miscptr = strchr(in_buffer, '/');
		if(miscptr)
			{
			switch(toupper(*(miscptr+1)))
				{
				case 'D':
					if ((j = toupper(*(miscptr+3))) >= 'A' && j <= 'Z')
						strcpy(filename,(miscptr+3));
					else
						command_hlp("Illegal drive letter in command line syntax.");
					break;
				case 'Z':         /* Delete temporary files. */
					++zaptemp;
					break;

				default:
					command_hlp("Command line option not defined.");
				}
			}
		else
			command_hlp("Illegal command line syntax.");
		}
	}

else
	{
	puts("\nPlease enter the full path and name of the file to strip.");

	printf("\nFile name\\path is: ");
	gets(filename);
	}

/* Now to make the temporary filename, filename.$$$ */
strcpy(filetemp, filename);
ptr = strrchr(filetemp, '.');
if (ptr)
	*ptr = 0;

strcat(filetemp, ".$$$");

/* Now to remove/delete the temporary file if it exists.*/
remove(filetemp);

/* Now to rename the original file to the temp. */
if (rename(filename, filetemp) != 0)
	{
	/*clrscr();*/
	strcpy(errormsg, "\n\nFATAL ERROR renaming file ");
	strcat(errormsg, strupr(filename));
	error(errormsg);
	exit(1);
	}


infile = fopen(filetemp,"rb");
if(!infile)
	{
	/*clrscr();*/
	strcpy(errormsg, "\n\nFATAL ERROR read opening file ");
	strcat(errormsg, strupr(filetemp));
	error(errormsg);
	exit(1);
	}

outfile = fopen(filename,"wb");
if(!outfile)
	{
	/*clrscr();*/
	strcpy(errormsg, "\n\nFATAL ERROR write opening file ");
	strcat(errormsg, strupr(filename));
	error(errormsg);
	exit(1);
	}

line=0;
printf("\n\nParsing file %s   ",strupr(filename));
cursoff();

do
	{
	for (i=0; i<1024; ++i)
		buffer[i] = 0;    /* Clear buffer area. */
	c=getc(infile);
	for(i=0; (i < 1024) && (feof(infile) == 0) && (c != 0x0A); ++i)
		{
		buffer[i] = c;
		c = getc(infile);
		}
	buffer[i]=c;

	/* Now we have a line of text. */
	++line;
	putchar(whirl[ line%5 ]);
	gotoxy(wherex()-1, wherey());

	ptr = strrchr(&buffer[0], ']');
	if (!ptr || (ptr && *(ptr+4)) || (ptr && (*(ptr-8) != '[')))
		/* ] char not found at all, or
		   ] char found and there's characters following, or
		   ] char found and there's not a [ char 8 letters preceeding;
			in these cases, we want to write line through to output.
		*/
		{
		num = fwrite( (void *)buffer, sizeof(char), strlen(&buffer[0]), outfile);
		if (num != strlen(&buffer[0]))
			{
			/* clrscr(); */
			strcpy(errormsg, "\n\n FATAL ERROR writing file ");
			strcat(errormsg, strupr(filename));
			error(errormsg);
			fcloseall();
			curson();
			exit(1);
			}
		}

	} while (feof(infile) == 0);

puts("Done!\n\n");
fcloseall();
curson();

/* For safety's sake, we won't delete the *.$$$ file at this time. */
if (zaptemp)
	remove(filetemp);

return(0);
}



/*
*************************************************************
*												*
*			           ERROR	 					*
*												*
*************************************************************
*/

void error(message)

char *message;

{

puts("\n");
puts(message);
puts("Please correct and try again.");
puts("\n");
puts("PRESS THE SPACE BAR TO CONTINUE");
while (scr_ci() != ' ')
      ;
}


/*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*							 				   *
*			      COMMAND_HLP   		 		   *
*							 				   *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

A routine to print command line help if an error has been made
and then exit the questrip program.
*/

void command_hlp(prompt)
	char *prompt;

{
clrscr();
prints(0,0,0x07,prompt);

prints(2,0,0x07,"The command line syntax for QUESTRIP is as follows:");
prints(4,0,0x07,"       /D=<Drive:\\path\\filename>     For file to process.");
prints(5,0,0x07,"       /Z     Zaps temp file.  Otherwise, temps kept as backup.");
prints(7,0,0x07,"For example:   QUESTRIP /Z /D=C:\\WC30\\QUES\\QUES0001.001");

gotoxy_(20,0);
curson();      /* Enable the cursor */
exit(1);
}
